import sys
import subprocess
from pyexcel_ods import *
from pysam import VariantFile
import htmltag

" construction du formulaire en premier "
head = htmltag.HEAD()
head = htmltag.append(htmltag.TITLE('pharmacogenetic'))
head = head.append(htmltag.STYLE(type="text/css").append("body { padding-left: 15em; font-family: Georgia; color:black }"))
head = head.append(htmltag.STYLE(type="text/css").append("h2 { padding-left: 15em;font-family: Georgia;color:blue }"))
head = head.append(htmltag.STYLE(type="text/css").append("ul.navbar { list-style-type: none; padding: 0; margin: 0; position: absolute; top: 2em; left: 1em; width: 13em }"))
head = head.append(htmltag.STYLE(type="text/css").append("ul.navbar li { background: yellow; margin: 0.5em 0; padding: 1em; border-left: 0.5em solid black }"))
head = head.append(htmltag.STYLE(type="text/css").append("P1 {color: red }"))
head = head.append(htmltag.STYLE(type="text/css").append("P2 { color: orange }"))


body = htmltag.BODY()
body = body.append(htmltag.UL(CLASS = "navbar").append(htmltag.UL(htmltag.LI(htmltag.A(href = "https://www.pharmgkb.org").append("pharmgkb")))).append(htmltag.UL(htmltag.LI(htmltag.A(href = "https://cpicpgx.org").append("cpicpgx")))).append(htmltag.UL(htmltag.LI(htmltag.A(href = "http://www.pharmacogenetics.fr/").append("pharmacogenetics.fr")))))
body = body.append(htmltag.H2('Variants pharmgkb'))

"""extraction des donnees """
data = get_data("/work/gad/sv347413/epilepsie/Pipeline/tableau pharmgkb.ods")
vcf_reader_SNP = VariantFile(sys.argv[1])
vcf_reader_CNV = VariantFile(sys.argv[2])
BAM_FILE = VariantFile(sys.argv[4])
Report_HLA = open(sys.argv[3],"r")

for record in vcf_reader_SNP.fetch():
    try:
        for i in range(len(record.info["Pharmaco_Annot"])/12):
            try:
                gene = repr(record.info["GENEINFO"])
            except:
                gene = "intron"
            alt = record.info["Pharmaco_Annot"][(i*12)+1].replace(")","").replace("'","").replace("-","")
            pheno = record.info["Pharmaco_Annot"][(i*12)+3].replace(")","").replace("'","").replace("-"," ")
            publi = record.info["Pharmaco_Annot"][(i*12)+5].replace(")","").replace("'","").replace("-"," ")
            level = record.info["Pharmaco_Annot"][(i*12)+7].replace(")","").replace("'","").replace("-","")
            patho = record.info["Pharmaco_Annot"][(i*12)+9].replace(")","").replace("'","").replace("-","")
            molecule = record.info["Pharmaco_Annot"][(i*12)+11].replace(")","").replace("'","").replace("-"," ").replace("]","")
            if level.startswith("1"):
                body= body.append(htmltag.P(htmltag.P1("pathologie: "+patho))+htmltag.P(htmltag.P1("molecule: "+molecule))+htmltag.P(htmltag.P1("gene: "+gene))+htmltag.P(htmltag.P1("variant: "+repr(record.pos)+" "+repr(record.ref)+">"+repr(record.alts)+" "+repr(record.id)))+htmltag.P(htmltag.P1("base alternative: "+alt))+htmltag.P(htmltag.P1("niveau: "+level))+htmltag.P(htmltag.P1("phenotype: "+pheno)))
		body= body.append(htmltag.P(htmltag.P1(htmltag.A(href = publi).append("publication: "+publi))))
            elif level.startswith("2"):
                body= body.append(htmltag.P(htmltag.P2("pathologie: "+patho))+htmltag.P(htmltag.P2("molecule: "+molecule))+htmltag.P(htmltag.P2("gene: "+gene))+htmltag.P(htmltag.P2("variant: "+repr(record.pos)+" "+repr(record.ref)+">"+repr(record.alts)+" "+repr(record.id)))+htmltag.P(htmltag.P2("base alternative: "+alt))+htmltag.P(htmltag.P2("niveau: "+level))+htmltag.P(htmltag.P2("phenotype: "+pheno)))
		body= body.append(htmltag.P(htmltag.P2(htmltag.A(href = publi).append("publication: "+publi))))
            else :
                body= body.append(htmltag.P("pathologie: "+patho)+htmltag.P("molecule: "+molecule)+htmltag.P("gene: "+gene)+htmltag.P("variant: "+repr(record.pos)+" "+repr(record.ref)+">"+repr(record.alts)+" "+repr(record.id))+htmltag.P("base alternative: "+alt)+htmltag.P("niveau: "+level)+htmltag.P(htmltag.P("phenotype: "+pheno)))
		body= body.append(htmltag.P(htmltag.A(href = publi).append("publication: "+publi)))
            body= body.append(htmltag.P("#######################################################################"))
    except:
        pass

body = body.append(htmltag.H2('Deletion ou duplication'))

for record in vcf_reader_CNV.fetch():
    for elm in record.alts:
        if elm == "<DEL>":
            ListeM = []
            ListeD = []
            body= body.append(htmltag.P("Deletion detectee par xHMM sur le gene "+record.info["GENE"]))
            for i in range(len(data["hg19"])-1):
                if not data["hg19"][i]:
                    pass
                else:
                    if data["hg19"][i][1] != "gene":
                        if data["hg19"][i][1] == record.info["GENE"]:
                            if data["hg19"][i][0] not in ListeM:
                                ListeM.append(data["hg19"][i][0])
            for Mol in ListeM:
                body= body.append(htmltag.P("######Gene ayant une relation avec :"+Mol))
            depth_ave = 0.0
            pos_len = 0
            depth_new = 0
            p = subprocess.Popen(["samtools", 'depth', BAM_FILE, '-r', record.chrom + ':' + str(record.pos) + '-'\
            + str(record.stop)], stdout = subprocess.PIPE)
            for line in p.stdout.readlines():
                item = line.split()
                if len(item) == 3:
                    ListeD.append(item[2])
                    for elm in ListeD:
                        depth_new = depth_new + int(elm)
                    depth_ave = depth_ave + float(item[2])
                    pos_len = pos_len + (int(record.stop) - int(record.pos) + 1)
            depth_ave = depth_new/float(pos_len)
            if depth_ave > 40:
                body= body.append(htmltag.P("######Detecte heterozygote, profondeur moyenne :"+depth_ave))
            if depth_ave < 10:
                body= body.append(htmltag.P("######Detecte  homozygote, profondeur moyenne :"+depth_ave))
            else:
                body= body.append(htmltag.P("######Detecte probablement heterozygote, profondeur moyenne :"+depth_ave))
        if elm == "<DUP>":
	    ListeM = []
            body= body.append(htmltag.P("Duplication detectee par xHMM sur le gene "+record.info["GENE"]))
            for i in range(len(data["hg19"])-1):
                if not data["hg19"][i]:
                    pass
                else:
                    if data["hg19"][i][1] != "gene":
                        if data["hg19"][i][1] == record.info["GENE"]:
                            if data["hg19"][i][0] not in ListeM:
                                ListeM.append(data["hg19"][i][0])
            for Mol in ListeM:
                body= body.append(htmltag.P("######Gene ayant une relation avec :"+Mol))
HLA = Report_HLA.readlines()
ListeA = []
ListeB = []
ListeC = []
ListeDQB1 = []
ListeDRB1 = []
for lines in HLA :
    if lines.startswith("A"):
        for ligne in lines.split("\t"):
            if ligne.startswith("A*"):
                ListeA.append(ligne)
    if lines.startswith("B"):
        for ligne in lines.split("\t"):
            if ligne.startswith("B*"):
                ListeB.append(ligne)
    if lines.startswith("C"):
        for ligne in lines.split("\t"):
            if ligne.startswith("C*"):
                ListeC.append(ligne)
    if lines.startswith("DQB1"):
        for ligne in lines.split("\t"):
            if ligne.startswith("DQB1*"):
                ListeDQB1.append(ligne)
    if lines.startswith("DRB1"):
        for ligne in lines.split("\t"):
            if ligne.startswith("DRB1*"):
                ListeDRB1.append(ligne)

body = body.append(htmltag.H2('Resultat genotypage HLA'))
body = body.append(htmltag.P("HLA-A : "+ListeA[0]+" /  "+ListeA[1]))
body = body.append(htmltag.P("HLA-B : "+ListeB[0]+"  / "+ListeB[1]))
body = body.append(htmltag.P("HLA-C : "+ListeC[0]+"  / "+ListeC[1]))
body = body.append(htmltag.P("HLA-DQB1 : "+ListeDQB1[0]+" /  "+ListeDQB1[1]))
body = body.append(htmltag.P("HLA-DRB1 : "+ListeDRB1[0]+"  / "+ListeDRB1[1]))

for i in range(len(data["hg19"])-1):
    if not data["hg19"][i]:
        pass
    else:
        if data["hg19"][i][1] != "gene":
            if data["hg19"][i][2].startswith("HLA-A"):
                Adigit = data["hg19"][i][2].split("*")[1]
                Adigit2 = Adigit.split(":")[0]+Adigit.split(":")[1]
                HL1 = ListeA[0].split("*")[1].split(":")[0]+ListeA[0].split("*")[1].split(":")[1]
                HL2 = ListeA[1].split("*")[1].split(":")[0]+ListeA[1].split("*")[1].split(":")[1]
                if HL1 == Adigit2:
                    pheno = data["hg19"][i][4]
                    publi = data["hg19"][i][5]
                    level = str(data["hg19"][i][10])
                    if level.startswith("1"):
                        body = body.append(htmltag.P1(htmltag.P(pheno)+htmltag.P(level)))
			body = body.append(htmltag.P1(htmltag.P(htmltag.A(href = publi).append("publication: "+publi))))
                    if level.startswith("2"):
                        body = body.append(htmltag.P2(htmltag.P(pheno)+htmltag.P(level)))
			body = body.append(htmltag.P1(htmltag.P(htmltag.A(href = publi).append("publication: "+publi))))
                    else:
                        body = body.append(htmltag.P(pheno)+htmltag.P(level))
			body = body.append(htmltag.P1(htmltag.P(htmltag.A(href = publi).append("publication: "+publi))))
                if HL2 == Adigit2:
                    pheno = data["hg19"][i][4]
                    publi = data["hg19"][i][5]
                    level = str(data["hg19"][i][10])
                    if level.startswith("1"):
                        body = body.append(htmltag.P1(htmltag.P(pheno)+htmltag.P(level)))
			body = body.append(htmltag.P1(htmltag.P(htmltag.A(href = publi).append("publication: "+publi))))
                    if level.startswith("2"):
                        body = body.append(htmltag.P2(htmltag.P(pheno)+htmltag.P(level)))
			body = body.append(htmltag.P1(htmltag.P(htmltag.A(href = publi).append("publication: "+publi))))
                    else:
                        body = body.append(htmltag.P(pheno)+htmltag.P(level))
			body = body.append(htmltag.P1(htmltag.P(htmltag.A(href = publi).append("publication: "+publi))))

            if data["hg19"][i][2].startswith("HLA-B"):
                Bdigit = data["hg19"][i][2].split("*")[1]
                Bdigit2 = Adigit.split(":")[0]+Adigit.split(":")[1]
                HL1 = ListeB[0].split("*")[1].split(":")[0]+ListeA[0].split("*")[1].split(":")[1]
                HL2 = ListeB[1].split("*")[1].split(":")[0]+ListeA[1].split("*")[1].split(":")[1]
                if HL1 == Bdigit2:
                    pheno = data["hg19"][i][4]
                    publi = data["hg19"][i][5]
                    level = str(data["hg19"][i][10])
                    if level.startswith("1"):
                        body = body.append(htmltag.P1(htmltag.P(pheno)+htmltag.P(level)))
			body = body.append(htmltag.P1(htmltag.P(htmltag.A(href = publi).append("publication: "+publi))))
                    if level.startswith("2"):
                        body = body.append(htmltag.P2(htmltag.P(pheno)+htmltag.P(level)))
			body = body.append(htmltag.P2(htmltag.P(htmltag.A(href = publi).append("publication: "+publi))))
                    else:
                        body = body.append(htmltag.P(pheno)+htmltag.P(level))
			body = body.append(htmltag.P(htmltag.P(htmltag.A(href = publi).append("publication: "+publi))))
                if HL2 == Bdigit2:
                    pheno = data["hg19"][i][4]
                    publi = data["hg19"][i][5]
                    level = str(data["hg19"][i][10])
                    if level.startswith("1"):
                        body = body.append(htmltag.P1(htmltag.P(pheno)+htmltag.P(level)))
			body = body.append(htmltag.P1(htmltag.P(htmltag.A(href = publi).append("publication: "+publi))))
                    if level.startswith("2"):
                        body = body.append(htmltag.P2(htmltag.P(pheno)+htmltag.P(level)))
			body = body.append(htmltag.P2(htmltag.P(htmltag.A(href = publi).append("publication: "+publi))))
                    else:
                        body = body.append(htmltag.P(pheno)+htmltag.P(level))
			body = body.append(htmltag.P(htmltag.P(htmltag.A(href = publi).append("publication: "+publi))))

print htmltag.HTML(head+body)
